<?php

require_once "../../../modelos/conexion.php";

require_once('tcpdf_include.php');
require_once('qr/qrlib.php');
$codesDir = "codes/";
$codeFile = date('d-m-Y-h-i-s').'.png';

	//====================================================================
	function get_nombre_xxx($id,$tabla,$valor){
	  $mysqli=conectar();
	  $error=0;

	  $cadena="select ".$valor." from tabla_".$tabla." where idtabla_".$tabla."='".$id."'";
	  $req=$mysqli->query($cadena) or ($error=1);

	  $r=$req->fetch_assoc();

	  if($error==0){
	  	if(isset($r[$valor])){
			return $r[$valor];
		}else{
			return $cadena;
		}

	  }else{

	  	return 'Error al obtener '.$valor.'...';
	  }

	}
	//====================================================================

    //===================================================================
	function numtoletras($xcifra)
	{
		$xarray = array(0 => "Cero",
			1 => "UN", "DOS", "TRES", "CUATRO", "CINCO", "SEIS", "SIETE", "OCHO", "NUEVE",
			"DIEZ", "ONCE", "DOCE", "TRECE", "CATORCE", "QUINCE", "DIECISEIS", "DIECISIETE", "DIECIOCHO", "DIECINUEVE",
			"VEINTI", 30 => "TREINTA", 40 => "CUARENTA", 50 => "CINCUENTA", 60 => "SESENTA", 70 => "SETENTA", 80 => "OCHENTA", 90 => "NOVENTA",
			100 => "CIENTO", 200 => "DOSCIENTOS", 300 => "TRESCIENTOS", 400 => "CUATROCIENTOS", 500 => "QUINIENTOS", 600 => "SEISCIENTOS", 700 => "SETECIENTOS", 800 => "OCHOCIENTOS", 900 => "NOVECIENTOS"
		);
	//
		$xcifra = trim($xcifra);
		$xlength = strlen($xcifra);
		$xpos_punto = strpos($xcifra, ".");
		$xaux_int = $xcifra;
		$xdecimales = "00";
		if (!($xpos_punto === false)) {
			if ($xpos_punto == 0) {
				$xcifra = "0" . $xcifra;
				$xpos_punto = strpos($xcifra, ".");
			}
			$xaux_int = substr($xcifra, 0, $xpos_punto); // obtengo el entero de la cifra a covertir
			$xdecimales = substr($xcifra . "00", $xpos_punto + 1, 2); // obtengo los valores decimales
		}

		$XAUX = str_pad($xaux_int, 18, " ", STR_PAD_LEFT); // ajusto la longitud de la cifra, para que sea divisible por centenas de miles (grupos de 6)
		$xcadena = "";
		for ($xz = 0; $xz < 3; $xz++) {
			$xaux = substr($XAUX, $xz * 6, 6);
			$xi = 0;
			$xlimite = 6; // inicializo el contador de centenas xi y establezco el límite a 6 dígitos en la parte entera
			$xexit = true; // bandera para controlar el ciclo del While
			while ($xexit) {
				if ($xi == $xlimite) { // si ya llegó al límite máximo de enteros
					break; // termina el ciclo
				}

				$x3digitos = ($xlimite - $xi) * -1; // comienzo con los tres primeros digitos de la cifra, comenzando por la izquierda
				$xaux = substr($xaux, $x3digitos, abs($x3digitos)); // obtengo la centena (los tres dígitos)
				for ($xy = 1; $xy < 4; $xy++) { // ciclo para revisar centenas, decenas y unidades, en ese orden
					switch ($xy) {
						case 1: // checa las centenas
							if (substr($xaux, 0, 3) < 100) { // si el grupo de tres dígitos es menor a una centena ( < 99) no hace nada y pasa a revisar las decenas

							} else {
								$key = (int) substr($xaux, 0, 3);
								if (TRUE === array_key_exists($key, $xarray)){  // busco si la centena es número redondo (100, 200, 300, 400, etc..)
									$xseek = $xarray[$key];
									$xsub = subfijo($xaux); // devuelve el subfijo correspondiente (Millón, Millones, Mil o nada)
									if (substr($xaux, 0, 3) == 100)
										$xcadena = " " . $xcadena . " CIEN " . $xsub;
									else
										$xcadena = " " . $xcadena . " " . $xseek . " " . $xsub;
									$xy = 3; // la centena fue redonda, entonces termino el ciclo del for y ya no reviso decenas ni unidades
								}
								else { // entra aquí si la centena no fue numero redondo (101, 253, 120, 980, etc.)
									$key = (int) substr($xaux, 0, 1) * 100;
									$xseek = $xarray[$key]; // toma el primer caracter de la centena y lo multiplica por cien y lo busca en el arreglo (para que busque 100,200,300, etc)
									$xcadena = " " . $xcadena . " " . $xseek;
								} // ENDIF ($xseek)
							} // ENDIF (substr($xaux, 0, 3) < 100)
							break;
						case 2: // checa las decenas (con la misma lógica que las centenas)
							if (substr($xaux, 1, 2) < 10) {

							} else {
								$key = (int) substr($xaux, 1, 2);
								if (TRUE === array_key_exists($key, $xarray)) {
									$xseek = $xarray[$key];
									$xsub = subfijo($xaux);
									if (substr($xaux, 1, 2) == 20)
										$xcadena = " " . $xcadena . " VEINTE " . $xsub;
									else
										$xcadena = " " . $xcadena . " " . $xseek . " " . $xsub;
									$xy = 3;
								}
								else {
									$key = (int) substr($xaux, 1, 1) * 10;
									$xseek = $xarray[$key];
									if (20 == substr($xaux, 1, 1) * 10)
										$xcadena = " " . $xcadena . " " . $xseek;
									else
										$xcadena = " " . $xcadena . " " . $xseek . " Y ";
								} // ENDIF ($xseek)
							} // ENDIF (substr($xaux, 1, 2) < 10)
							break;
						case 3: // checa las unidades
							if (substr($xaux, 2, 1) < 1) { // si la unidad es cero, ya no hace nada

							} else {
								$key = (int) substr($xaux, 2, 1);
								$xseek = $xarray[$key]; // obtengo directamente el valor de la unidad (del uno al nueve)
								$xsub = subfijo($xaux);
								$xcadena = " " . $xcadena . " " . $xseek . " " . $xsub;
							} // ENDIF (substr($xaux, 2, 1) < 1)
							break;
					} // END SWITCH
				} // END FOR
				$xi = $xi + 3;
			} // ENDDO

			if (substr(trim($xcadena), -5, 5) == "ILLON") // si la cadena obtenida termina en MILLON o BILLON, entonces le agrega al final la conjuncion DE
				$xcadena.= " DE";

			if (substr(trim($xcadena), -7, 7) == "ILLONES") // si la cadena obtenida en MILLONES o BILLONES, entoncea le agrega al final la conjuncion DE
				$xcadena.= " DE";

			// ----------- esta línea la puedes cambiar de acuerdo a tus necesidades o a tu país -------
			if (trim($xaux) != "") {
				switch ($xz) {
					case 0:
						if (trim(substr($XAUX, $xz * 6, 6)) == "1")
							$xcadena.= "UN BILLON ";
						else
							$xcadena.= " BILLONES ";
						break;
					case 1:
						if (trim(substr($XAUX, $xz * 6, 6)) == "1")
							$xcadena.= "UN MILLON ";
						else
							$xcadena.= " MILLONES ";
						break;
					case 2:
						if ($xcifra < 1) {
							$xcadena = "CERO   Y $xdecimales/100 CENTIMOS";
						}
						if ($xcifra >= 1 && $xcifra < 2) {
							$xcadena = "UN   Y $xdecimales/100 CENTIMOS ";
						}
						if ($xcifra >= 2) {
							$xcadena.= " SOLES  Y $xdecimales/100 CENTIMOS "; //
						}
						break;
				} // endswitch ($xz)
			} // ENDIF (trim($xaux) != "")
			// ------------------      en este caso, para México se usa esta leyenda     ----------------
			$xcadena = str_replace("VEINTI ", "VEINTI", $xcadena); // quito el espacio para el VEINTI, para que quede: VEINTICUATRO, VEINTIUN, VEINTIDOS, etc
			$xcadena = str_replace("  ", " ", $xcadena); // quito espacios dobles
			$xcadena = str_replace("UN UN", "UN", $xcadena); // quito la duplicidad
			$xcadena = str_replace("  ", " ", $xcadena); // quito espacios dobles
			$xcadena = str_replace("BILLON DE MILLONES", "BILLON DE", $xcadena); // corrigo la leyenda
			$xcadena = str_replace("BILLONES DE MILLONES", "BILLONES DE", $xcadena); // corrigo la leyenda
			$xcadena = str_replace("DE UN", "UN", $xcadena); // corrigo la leyenda
		} // ENDFOR ($xz)
		return trim($xcadena);
	}

	// END FUNCTION

	function subfijo($xx)
	{ // esta función regresa un subfijo para la cifra
		$xx = trim($xx);
		$xstrlen = strlen($xx);
		if ($xstrlen == 1 || $xstrlen == 2 || $xstrlen == 3)
			$xsub = "";
		//
		if ($xstrlen == 4 || $xstrlen == 5 || $xstrlen == 6)
			$xsub = "MIL";
		//
		return $xsub;
	}
    //===================================================================
//$pdf = new TCPDF('P', PDF_UNIT, 'A7', true, 'UTF-8', false);
$medidas = array(80, 300); // Ajustar aqui segun los milimetros necesarios;
$pdf = new TCPDF('P', 'mm', $medidas, true, 'UTF-8', false);
$pdf->SetMargins(3, 0, 2);
$pdf->SetDisplayMode('fullpage', 'continuous', 'UseNone');
$pdf->startPageGroup();
// remove default header/footer
$pdf->setPrintHeader(false);
$pdf->setPrintFooter(false);
/*
$medidas = array(80, 296); // Ajustar aqui segun los milimetros necesarios;
$pdf = new TCPDF('P', 'mm', $medidas, true, 'UTF-8', false);

//$pdf = new TCPDF('P', PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);
$pdf->SetMargins(4, 4, 1);
$pdf->SetDisplayMode('fullpage', 'continuous', 'UseNone');
$pdf->startPageGroup();
*/

$pdf->AddPage();


// ---------------------------------------------------------
$mysqli=conectar();
$id=$_GET['id'];

$serie=get_nombre_xxx($id,'pasaje','serie');
$correlativo=get_nombre_xxx($id,'pasaje','correlativo');



$pos = strpos($serie, 'B');
$tipodocumento='';
if ($pos === false) {
	$tipodocumento="FACTURA ELECTRONICA";
} else {
	$tipodocumento="BOLETA ELECTRONICA";
}



$precio=get_nombre_xxx($id,'pasaje','precio');
$montotextp=numtoletras($precio);
$asiento=get_nombre_xxx($id,'pasaje','asiento');

$fecharegistro=get_nombre_xxx($id,'pasaje','fecha');
$horaregistro=get_nombre_xxx($id,'pasaje','hora');
$fechahora=$fecharegistro.'  '.$horaregistro;


$idusuariopsj=get_nombre_xxx($id,'pasaje','idtabla_usuario');
if($idusuariopsj==0){
	$usuariopsj="Demo";
}else{
	$usuariopsj=get_nombre_xxx($idusuariopsj,'usuario','usuario');
}



$idcliente=get_nombre_xxx($id,'pasaje','idtabla_cliente');
$nombre=get_nombre_xxx($idcliente,'cliente','nombre');
$documento=get_nombre_xxx($idcliente,'cliente','documento');
$telefono=get_nombre_xxx($idcliente,'cliente','telefono');

$idtabla_clienteruc=get_nombre_xxx($id,'pasaje','idtabla_clienteruc');

$nombreempresa='-';  $ruc='-'; $direccionempresa='-';
if($idtabla_clienteruc>0){
	$nombreempresa=get_nombre_xxx($idtabla_clienteruc,'cliente','nombre');
	$nombreempresa=str_replace('$','&',$nombreempresa);
	$ruc=get_nombre_xxx($idtabla_clienteruc,'cliente','documento');
	$direccionempresa=get_nombre_xxx($idtabla_clienteruc,'cliente','direccion');

}

$iditinerario=get_nombre_xxx($id,'pasaje','idtabla_itinerario');
if($iditinerario<0){$iditinerario=$iditinerario*-1;}

$idtabla_bus=get_nombre_xxx($iditinerario,'itinerario','idtabla_bus');

//================================================================
$placa=get_nombre_xxx($idtabla_bus,'bus','placa');
$busdata=trim($placa);
$poliza='';


if(strcmp(trim($busdata), 'D4A-960')==0 ){
	$poliza='Cubierto por poliza de seguros La Positiva <br>N° 3300012257-55';
}

if(strcmp(trim($busdata), 'D4B-956')==0){
	$poliza='Cubierto por poliza de seguros La Positiva <br>N° 3300012257-57';
}

if(strcmp(trim($busdata), 'D4B-954')==0){
	$poliza='Cubierto por poliza de seguros La Positiva <br>N° 3300012257-56';
}

if(strcmp(trim($busdata), 'D4D-952')==0){
	$poliza='Cubierto por poliza de seguros La Positiva <br>N° 3300012257-58';
}
//================================================================
$idlugarembarque=get_nombre_xxx($id,'pasaje','idtabla_ciudadembarque');

$idorigen=get_nombre_xxx($iditinerario,'itinerario','idorigen');
$origen=get_nombre_xxx($idorigen,'ciudad','nombre');

if($idlugarembarque>0){
	$origen=get_nombre_xxx($idlugarembarque,'ciudad1','nombre');
}

$iddestino=get_nombre_xxx($iditinerario,'itinerario','iddestino');
$destino=get_nombre_xxx($iddestino,'ciudad','nombre');



$fechaviaje=get_nombre_xxx($iditinerario,'itinerario','fecha');
$dt=explode("-",trim($fechaviaje));
$fechaviaje=$dt[2].'-'.$dt[1].'-'.$dt[0];

$horaviaje=date("g:i a",strtotime(get_nombre_xxx($iditinerario,'itinerario','horaviaje')));

$horaembarque=get_nombre_xxx($id,'pasaje','horaembarque');
if(trim($horaembarque)!='00:00:00'){
	$horaviaje=date("g:i a",strtotime($horaembarque));
}



$idembarque=get_nombre_xxx($iditinerario,'itinerario','idembarque');
$embarque=get_nombre_xxx($idembarque,'direccion','nombre');

$iddesembarque=get_nombre_xxx($iditinerario,'itinerario','iddesembarque');
$desembarque=get_nombre_xxx($iddesembarque,'direccion','nombre');

$idtabla_empresa=get_nombre_xxx($iditinerario,'itinerario','idtabla_empresa');
$local=get_nombre_xxx($idtabla_empresa,'empresa','nombre');
$localruc=get_nombre_xxx($idtabla_empresa,'empresa','ruc');


$grabado=$precio/1.18;
$igv=($grabado*18)/100;

$grabado=round($grabado,2);
$igv=round($igv,2);

$qr='http://transportecontinentalpacifico.com/xml/  Pasajero:'.$nombre.' '.$documento.' '.$nombreempresa.' '.$ruc.' '.$fechaviaje.' - '.$horaviaje.' '.$origen.' '.$destino.' Asiento:'.$asiento.' '.$serie.'-'.$correlativo.'  S/'.$precio;
QRcode::png($qr, $codesDir.$codeFile, 'H', 1);

//<tr><td colspan="3" align="center">'.strtoupper($tipodocumento).'</td></tr>
$tabla= '<table  style=" width:215px;font-size:8px;  font-weight: bold; margin-top: -10px;" >
	<tr><td colspan="3" align="center"><img src="imagen.png"></td></tr>
	<tr><td colspan="3" align="center">'.strtoupper($local).'</td></tr>
	<tr><td colspan="3" align="center">'.strtoupper($localruc).'</td></tr>
	
	<tr><td colspan="3" align="center">DOCUMENTO ELECTRONICO</td></tr>
	<tr><td colspan="3" align="center">'.strtoupper($serie).'-'.strtoupper($correlativo).'</td></tr>
	<tr><td colspan="3"><br></td></tr>
	</table>
    
    <table  style=" width:225px;font-size:8px;  font-weight: bold;" >
	<tr> <td style="width: 60px">PAGO CON</td><td style="width: 10px" align="left">:</td><td style="width: 155px" align="left">EFECTIVO</td></tr>
	<tr> <td style="width: 60px">EMISION</td><td style="width: 10px" align="left">:</td><td style="width: 155px" align="left">'.$fechahora.'</td></tr>
	<tr> <td>DOCUMENTO</td><td align="left">:</td><td align="left">'.$documento.'</td></tr>
	<tr> <td>TELEFONO</td><td align="left">:</td><td align="left">'.$telefono.'</td></tr>
	<tr> <td>PASAJERO</td><td align="left">:</td><td align="left">'.$nombre.'</td></tr>
	<tr> <td>RUC</td><td align="left">:</td><td>'.$ruc.'</td></tr>
	<tr> <td>EMPRESA</td><td align="left">:</td><td align="left">'.$nombreempresa.'</td></tr>
	<tr> <td>DIRECCION</td><td align="left">:</td><td align="left">'.$direccionempresa.'</td></tr>
	<tr> <td>CAJERO</td><td align="left">:</td><td align="left">'.$usuariopsj.'</td></tr>
	
	<tr><td colspan="3">---------------------------------------------------------------------------------</td></tr>
	<tr><td colspan="3" align="center">DETALLE</td></tr>	
	<tr><td colspan="3">---------------------------------------------------------------------------------</td></tr>
    </table>
    
    <table  style="border: 1px solid red; width:225px;font-size:8px;  font-weight: bold;" >
	<tr> <td style="width: 70px">ORIGEN</td><td style="width: 10px">:</td><td style="width: 145px;font-size:10px;">'.strtoupper($origen).'</td></tr>
	<tr> <td>DESTINO</td><td>:</td><td style="font-size:10px;">'.strtoupper($destino).'</td></tr>	
	<tr> <td>FECHA VIAJE</td><td>:</td><td style="font-size: 10px; font-size:10px;">'.$fechaviaje.'</td></tr>
	<tr> <td>HORA DE VIAJE</td><td>:</td><td style="font-size: 10px; font-size:10px;">'.$horaviaje.'</td></tr>
	<tr> <td>ASIENTO</td><td>:</td><td style="font-size:10px;">'.$asiento.'</td></tr>
	<tr> <td>EMBARQUE</td><td>:</td><td style="font-size: 7px">'.strtoupper($embarque).'</td></tr>
	<tr> <td>DESEMBARQUE</td><td>:</td><td style="font-size: 7px">'.strtoupper($desembarque).'</td></tr>		
	<tr><td colspan="3">---------------------------------------------------------------------------------</td></tr>
	
	<tr> <td>IMPORTE</td><td>:</td><td>S/ '.$precio.'</td></tr>
	<tr><td colspan="3"><br></td></tr>
	<tr><td colspan="3" align="left">SON '.$montotextp.'</td></tr>
	
	<tr><td colspan="3"><br></td></tr>
	<tr><td colspan="3" align="left">Cel Lima : 944067965</td></tr>
	<tr><td colspan="3" align="left">Cel Cajamrca : 913687415</td></tr>
	<tr><td colspan="3" align="left">Cel Puente Piedra : 975571147</td></tr>
	
	<tr><td colspan="3">---------------------------------------------------------------------------------</td></tr>
	
	
	<tr><td colspan="3" align="center" style="font-size: 9px;">'.strtolower($poliza).'
		</td></tr>
	<tr><td colspan="3">---------------------------------------------------------------------------------</td></tr>	
	<tr><td style="width: 95%;" colspan="3" align="justify" ><span style="font-weight: bold; font-size: 5px;">
	EL BOLETO ES PERSONAL E INTRANSFERIBLE Y VALIDO PARA LA FECHA Y HORA DE VIAJE, BAJO NINGÚN CONCEPTO HAY DEVOLUCIÓN DE DINERO UNA VEZ OTORGADO EL BOLETO DE VIAJE.
<br>
1-EL PASAJERO perderá su derecho a viajar y el valor integro de pasaje, cuando se encuentre bajo la influencia de alcohol y/o drogas, cuyo estado de salud no sea compatible con el viaje.<br>
2-EL TITULAR DEL BOLETO podrá postergar su viaje con 04 horas de anticipación en la misma oficina donde adquirió el boleto una sola vez.<br>
3-EL BOLETO ES EL ÚNICO comprobante para subir al vehículo, en caso de perdida el titular se apersonara a las oficinas con anticipación a gestionar otro comprobante previo pago del 20% del valor del boleto.<br>
4-EL PASAJERO deberá presentarse con 30 minutos antes la hora programada para el embarque a su destino, en caso de no encontrarse en el momento del control de pasajeros pierde su derecho a viajar y el valor integro del boleto.<br>
5- EL TITULAR DEL BOLETO a solicitud debla empresa presentara su DNI y/o cuando otra autoridad lo solicite y los datos del boleto y el documento personal debe ser los mismos.<br>
6-EL PASAJERO el pasajero tiene derecho a transportar 20Kg, el exceso que sera admitido cuando la capacidad del ómnibus lo permita previo pago de la tarifa vigente.<br>
7-SOLO SE ACEPTA solo se acepta como equipaje los que contenga objetos de uso personal corriente, queda prohibido el transporte de armas u otros objetos que signifiquen riesgo o molestia para otros pasajeros y/o seguridad del ómnibus incluyendo objetos de valor.<br>
8- LA EMPRESA NO se hace responsable de valores no declarados, equipajes mal embalados transportados por el pasajero.<br>
9-SI EL ÓMNIBUS sufre un retraso en su salida la empresa no se hará responsable  con los daños o perjuicios que esta demoras pudiera ocasionar al pasajero.<br>
10- LA EMPRESA por fuerza mayor  cancelara el viaje, en forma excepcional reembolsara su valor  del pasaje al titular del boleto.<br>
11-LA EMPRESA NO RECONOCERÁ la perdida de equipajes transportados en el salón del ómnibus.<br>
12-QUEDA PROHIBIDO Trasladar mascotas en el salón del ómnibus, en caso que la empresa autorice su traslado lo hará en la bodega dentro de una jaula de protección.<br>

NOTA: AL ADQUIRIR ESTE BOLETO EL TITULAR  OTORGA SU CONFORMIDAD Y ACEOTACION A LAS CLAUSULAS DE CONDICIONES DEL VIAJE IMPRESAS EN ESTE  DOCUMENTO.<br>

GRACIAS POR ELEGIR TRANSPORTE CONTINENTAL PACIFICO S.A.C.
</span>
</td></tr>

<tr><td colspan="3" align="left"> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img class="img-thumbnail" src="'.$codesDir.$codeFile.'" /></td></tr>
<tr><td colspan="3" align="left"> Descarga El Xml y Pdf de:<br> http://transportecontinentalpacifico.com/xml/</td></tr>		
	
';

$pdf->writeHTML($tabla, true, false, false, false, '');

// ---------------------------------------------------------

// ---------------------------------------------------------
//SALIDA DEL ARCHIVO

$pdf->Output('pasaje.pdf');


?>
