//======================================
function getXMLHTTPRequest()
{
var req = false;
try
  {
    req = new XMLHttpRequest(); /* p.e. Firefox */
  }
catch(err1)
  {
  try
    {
     req = new ActiveXObject("Msxml2.XMLHTTP");
  /* algunas versiones IE */
    }
  catch(err2)
    {
    try
      {
       req = new ActiveXObject("Microsoft.XMLHTTP");
  /* algunas versiones IE */
      }
      catch(err3)
        {
         req = false;
        }
    }
  }
return req;
}
//======================================

var peticion_cliente = null;
var elementoSeleccionado_cliente = -1;
var sugerencias_cliente = null;
var cacheSugerencias_cliente = {};


function inicializa_xhr() {
  if (window.XMLHttpRequest) {
    return new XMLHttpRequest(); 
  } else if (window.ActiveXObject) {
    return new ActiveXObject("Microsoft.XMLHTTP"); 
  } 
}

Array.prototype.formateaLista_cliente = function() {
  var codigoHtml = "";

  codigoHtml = "<table id='buscadorauntocompletar' style='font-size:12px;' >";
  for(var i=0; i<this.length; i++) {
  	  	
  	var cadena=this[i].split("#&");
  	
    if(i == elementoSeleccionado_cliente) {
            	
		codigoHtml +="<tr  onclick='clickcliente("+i+");'><td align='left'  class=\"seleccionado\">"+cadena[1]+"</td></tr>";
    }
    else { 
		codigoHtml +="<tr  onclick='clickcliente("+i+");'><td align='left' >"+cadena[1]+"</td></tr>";

    }
  }
  codigoHtml += "</table>";

  return codigoHtml;
};

function clickcliente(indicecliente){ 
	elementoSeleccionado_cliente=indicecliente;
	seleccionaElemento_cliente();
}

function autocompleta_cliente() {
  var elEvento = arguments[0] || window.event;
  var tecla = elEvento.keyCode;

  if(tecla == 40) { // Flecha Abajo
    if(elementoSeleccionado_cliente+1 < sugerencias_cliente.length) {
      elementoSeleccionado_cliente++;
    }
    muestraSugerencias_cliente();
  }
  else if(tecla == 38) { // Flecha Arriba
    if(elementoSeleccionado_cliente > 0) {
      elementoSeleccionado_cliente--;
    }
    muestraSugerencias_cliente();
  }
  else if(tecla == 13) { // ENTER o Intro
    seleccionaElemento_cliente();
  }
  else {
    var texto = document.getElementById("pasajero").value;

    // Si es la tecla de borrado y el texto es vacío, ocultar la lista
    if(tecla == 8 && texto == "") {
      borraLista_cliente();
      return;
    }
    
    if(cacheSugerencias_cliente[texto] == null) {
      peticion_cliente = inicializa_xhr();
      
      peticion_cliente.onreadystatechange = function() { 
        if(peticion_cliente.readyState == 4) {
          if(peticion_cliente.status == 200) {
            sugerencias_cliente =peticion_cliente.responseText; 
            if(sugerencias_cliente.length == 0) {
              sinResultados_cliente();
            }
            else {
              cacheSugerencias_cliente[texto] = sugerencias_cliente;
              actualizaSugerencias_cliente();
            }
          }
        }
      };
      
      
      peticion_cliente.open('POST', 'vistas/scripts/autocompleta_cliente.php?nocache='+Math.random(), true);
      peticion_cliente.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
      peticion_cliente.send('cliente='+encodeURIComponent(texto));
    }
    else {
      sugerencias_cliente = cacheSugerencias_cliente[texto];
      actualizaSugerencias_cliente();
    }
  }
}




function sinResultados_cliente() {
  	
  document.getElementById("sugerenciacliente").innerHTML = "<span style='background:white; color:red;'>No existen coicidencias con ese texto</span>";
  document.getElementById("sugerenciacliente").style.display = "block";
}

function actualizaSugerencias_cliente() {
  elementoSeleccionado_cliente = -1;
  muestraSugerencias_cliente();
}

function seleccionaElemento_cliente() {
  if(cadena[elementoSeleccionado_cliente]) {
  	var data=cadena[elementoSeleccionado_cliente].split("#&");

    document.getElementById("idcliente").value=data[0].trim();

    document.getElementById("pasajero").value=data[1].trim();

    document.getElementById("documento").value=data[2].trim();

    if(data[3].trim()==''){
      document.getElementById("telefono").value='00000000';
    }else{
      document.getElementById("telefono").value=data[3].trim();
    }

    if(data[4].trim()==''){
      document.getElementById("direccionpasajero").value='dir';
    }else{
      document.getElementById("direccionpasajero").value=data[4].trim();
    }



    document.getElementById("fechanacimiento").value=data[5].trim();

    document.getElementById("edad").value = data[6].trim();

    document.getElementById("sexo").value = data[7].trim();

    document.getElementById("encontrado").value = data[8].trim();

    if(data[8].trim()=='no'){
      document.getElementById("documento").readOnly = false;
      document.getElementById("telefono").readOnly = false;
      document.getElementById("fechanacimiento").readOnly = false;
      document.getElementById("direccionpasajero").readOnly = false;
    }

    if(data[8].trim()=='si'){
      document.getElementById("documento").readOnly = true;
      document.getElementById("telefono").readOnly = true;
      document.getElementById("fechanacimiento").readOnly = true;
      document.getElementById("direccionpasajero").readOnly = true;
    }

    if(data[7].trim()==''){

      document.getElementById("telefono").readOnly = false;
      document.getElementById("fechanacimiento").readOnly = false;
      document.getElementById("direccionpasajero").readOnly = false;
      document.getElementById("encontrado").value = 'no';
    }


    borraLista_cliente();

    if(data[7].trim()=='masculino' || data[7].trim()=='femenino'){

    }else{
      document.getElementById('hombre').style.visibility = "visible";
      document.getElementById('mujer').style.visibility = "visible";
    }

    if(document.getElementById('notacliente')){
	document.getElementById('notacliente').innerHTML='<span style="float:left; position: absolute; margin-left:220px; margin-top:-7px; color:#c60c0c; font-weight:bold;font-size:20px;" >'+data[1]+'</span>'
    }

    borraLista_cliente();

    if(data[0].trim()>0){
      var asiento=0; var itinerario=0; var idcli=data[0].trim();

      if(document.getElementById('itinerariodeviaje')){ itinerario=document.getElementById('itinerariodeviaje').value;}
      if(parseInt(itinerario)>0){
        var mi_aleatorio=parseInt(Math.random()*99999999);//para que no guarde la página en el caché...
        var vinculo="vistas/scripts/op_pasaje.php?accion=verificaasientoydni&aleatorio="+mi_aleatorio+"&iditinerario="+itinerario+"&idcli="+idcli;

        /*******************************************************************************/
        var miPeticion = getXMLHTTPRequest();
        miPeticion.open("GET",vinculo,false);//ponemos true para que la petición sea asincrónica
        miPeticion.onreadystatechange=miPeticion.onreadystatechange=function(){

          if (miPeticion.readyState==4)
          {
            if (miPeticion.status==200)
            {
              var http=miPeticion.responseText;
              var msj=http.trim();
              if(msj=='ok'){

              }else{
               // document.getElementById('botones').style.visibility = "hidden";
                var nota=' '+msj+' en este bus';

                //swal('El pasajero ya cuenta con un asiento '+msj+' en este bus');
                swal(' '+msj+' en este bus');
                document.getElementById('notacliente').innerHTML='<span style="float:left; position: absolute; margin-left:220px; margin-top:-7px; color:#c60c0c; font-weight:bold;font-size:20px;" >'+nota+'</span>';

              }


            }
          }
        };

        miPeticion.send(null);
        /***********************************************************************/
      }else{
        if(itinerario==-100){ //porque lo uso en los buscadores de los reportes

        }else{
          swal("Error al validar asiento disponible");
        }

      }

    }


  }
  
}

function muestraSugerencias_cliente() {
  var zonaSugerencias = document.getElementById("sugerenciacliente");  

  cadena=sugerencias_cliente.split(",");
  
  zonaSugerencias.innerHTML = cadena.formateaLista_cliente();
  zonaSugerencias.style.display = 'block';  
}

function borraLista_cliente() {
  document.getElementById("sugerenciacliente").innerHTML = "";
  document.getElementById("sugerenciacliente").style.display = "none";
  
}


function autocompletar_cliente(){
document.getElementById("pasajero").onkeyup = autocompleta_cliente;


}