<?php
require_once ("../../modelos/conexion.php");
require_once 'xml/ServicioSunat.php';
require_once 'lib/pclzip.lib.php';

// Nombre del Archivo a Procesar
/***********************************************************************************************/
$mysqli = conectar();
// Valor del Ticket
$ticket = trim($_GET['codigo']);

//******************BUSCO ID EMPRESA EN PASAJES*********************************************/
$dame="select  empresa from tabla_resumen_diario where codigo='".trim($ticket)."'";
$dataez=$mysqli->query($dame) or die ('Error al obtener identificador de la empresa' );

$empresbus='';
while($ab=$dataez->fetch_array()){
$empresbus=$ab['empresa'];
}
/***********************************************************************************************/


//**********************************************************************************************

$empre="select nombre,razonsocial,ruc,direccion,ubigeo,user,clave,link,ambiente,calle,departamento,provincia,distrito from tabla_empresa";
$empre=$empre." where idtabla_empresa='".$empresbus."'";
$srq=$mysqli->query($empre) or die ("error al obtener ruc de la empresa ".$empre);


$rucempresadata='';	$nameempresadata=''; $razonsocilaempresa=''; $direccion_empresa=''; $ubigeo='';
$usuariosunat=''; $clavesuant=''; $wsdl=''; $rutafe=''; $calle=''; $departamento=''; $provincia=''; $distrito='';

while($emps=$srq->fetch_array()){
	$rucempresadata=$emps['ruc'];
	$nameempresadata=$emps['nombre'];
	$razonsocilaempresa=$emps['razonsocial'];
	$direccion_empresa=$emps['direccion'];
	$ubigeo=$emps['ubigeo'];
	$usuariosunat=$emps['user'];
	$clavesuant=$emps['clave'];
	$wsdl=$emps['link'];
	$rutafe=$emps['ambiente'];
	$calle=$emps['calle'];
	$departamento=$emps['departamento'];
	$provincia=$emps['provincia'];
	$distrito=$emps['distrito'];
}
/***********************************************************************************************/
//**********************************************************************************************
$nombreArchivo = trim($_GET['nombre_archivo']);
$idcom_baja=trim($_GET['idcom_baja']);           
           
// URL para enviar las solicitudes a SUNAT
$wsdlURL = $wsdl;//'https://e-beta.sunat.gob.pe/ol-ti-itcpfegem-beta/billService?wsdl';
//$wsdlURL = 'wsdl/billService.wsdl';


// Estructura del XML para la conexión
$XMLString = '<?xml version="1.0" encoding="UTF-8"?>
<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:ser="http://service.sunat.gob.pe" xmlns:wsse="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd">
	<soapenv:Header>
		<wsse:Security>
			<wsse:UsernameToken Id="ABC-123">
					<wsse:Username>'.$usuariosunat.'</wsse:Username>
					<wsse:Password>'.$clavesuant.'</wsse:Password>
			</wsse:UsernameToken>
		</wsse:Security>
	</soapenv:Header>
	<soapenv:Body>
		<ser:getStatus>
			<ticket>' . $ticket . '</ticket>
		</ser:getStatus>
	</soapenv:Body>
</soapenv:Envelope>';

// Realizamos la llamada a nuestra función
$resultado = EnviarDocumento::soapCall($wsdlURL, $callFunction = "getStatus", $XMLString);

$error1   = 'HTTP';
$error2   = 'soap-env:Client';
$error3   = 'Could not connect to host';
$error4   = 'El ticket no existe';
$busqueda = strpos($resultado, $error1);
$busqueda1= strpos($resultado, $error2);
$busqueda2= strpos($resultado, $error3);
$busqueda3= strpos($resultado, $error4);


// Nótese el uso de ===. Puesto que == simple no funcionará como se espera

if ($busqueda === false and $busqueda1 === false and $busqueda2 === false and $busqueda3 === false) {
	
			$directoriocdr = 'resumen_respuesta';
			//================SI EXISTE LA RESPUESTA DE SUNAT LO ELIMINO - POR SEGURIDAD===================
			if (file_exists($directoriocdr.'/respuesta/'.$nombreArchivo . '.xml')){
				
				//si existe elimino el archivo	
				chmod($directoriocdr.'/respuesta/'.$nombreArchivo . '.xml', 0777);
				//rename($directoriocdr.'/respuetasunat/'.$nombreArchivo . '.xml', $directoriocdr.'/respuetasunat/'.$nombreArchivo . 'aa.xml');
				unlink($directoriocdr.'/respuesta/'.$nombreArchivo . '.xml');				
			}
			//===================================
			$archivo = fopen($directoriocdr.'/respuesta/'.$nombreArchivo . '.xml', 'w+');
			fputs($archivo, $resultado);
			fclose($archivo);
			chmod($directoriocdr.'/respuesta/'.$nombreArchivo . '.xml', 0777); //cambiamos permisos al archivo creado
			
			//leo es archivo descargado para ver el codigo de respeusta
			// Recuperamos la Información del CDR				
			$domDocument = new DOMDocument();
			$XMLString   = file_get_contents($directoriocdr.'/respuesta/'.$nombreArchivo . '.xml');
			$domDocument->loadXML($XMLString);
			
			$statusCode    = $domDocument->getElementsByTagName("statusCode")->item(0)->nodeValue;
			$content_respuesta  = $domDocument->getElementsByTagName("content")->item(0)->nodeValue;				
			$lng_resp=strlen($content_respuesta);
		
		if($statusCode==0 or $statusCode==99 or $statusCode==98){	
		/********************************************************************************************************/	
			// Leemos el Archivo de Respuesta de la SUNAT
			$xml = new DOMDocument();
			$xml->load($directoriocdr.'/respuesta/'.$nombreArchivo . '.xml');
			$xpath    = new DOMXPath($xml);
			$entradas = $xpath->query("//content");
			
			$nodeValue = "";
			
			foreach ($entradas as $response) {
			    $nodeValue = $response->nodeValue;
			}
			
			// Descargamos el CDR (Constancia de Recepción) Y creamos el zip					
								
			$rutaFinal  = $directoriocdr . '/' . '' . $nombreArchivo;
			$xmldescargado  = $directoriocdr . '/R-' . '' . $nombreArchivo; //asi lo decomprime el zip
			
			//================SI EXISTE EL ZIP DE SUNAT LO ELIMINO - POR SEGURIDAD===================
			if (file_exists($rutaFinal . '.zip')){	
				//si existe elimino el archivo	
				chmod($rutaFinal . '.zip', 0777);
				unlink($rutaFinal . '.zip');				
			}
			//===================================
			
			$cdr        = base64_decode($nodeValue);
			$archivo    = fopen($rutaFinal . '.zip', 'w+');
			fputs($archivo, $cdr);
			fclose($archivo);
			chmod($rutaFinal . '.zip', 0777);
			
			
			// Descomprimimos el Archizo .ZIP en un directorio
			//================SI EXISTE EL ARCHIVO DESCOMPRIMIDO DEL ZIP DE SUNAT LO ELIMINO - POR SEGURIDAD===================
			if (file_exists($rutaFinal . '.xml')){	
				//si existe elimino el archivo	
				chmod($rutaFinal . '.xml', 0777);
				unlink($rutaFinal . '.xml');				
			}
			//===================================
			$archive = new PclZip($rutaFinal . '.zip');
			if ($archive->extract(PCLZIP_OPT_PATH, $directoriocdr) == 0) {
			    die("Error : " . $archive->errorInfo(true));
			} else {
			    chmod($xmldescargado . '.xml', 0777);
			}
			
			
			// Recuperamos la Información del CDR				
			$domDocument = new DOMDocument();
			$XMLString   = file_get_contents($xmldescargado . '.xml');
			$domDocument->loadXML($XMLString);
			
			$mensajeCDR    = $domDocument->getElementsByTagName("Description")->item(0)->nodeValue;
			$fechaRespuesta = $domDocument->getElementsByTagName("ResponseDate")->item(0)->nodeValue;				
			$horaRespuesta = $domDocument->getElementsByTagName("ResponseTime")->item(0)->nodeValue;
			$codigoderespuesta  = $domDocument->getElementsByTagName("ResponseCode")->item(0)->nodeValue;
			$hash= $domDocument->getElementsByTagName("DigestValue")->item(0)->nodeValue;
	 /********************************************************************************************************/
	 }
			//por si me dice que el ticket no existe o algun otro menaje corto
			$nota='';
			if($lng_resp<=100){
				$nota='statusCode='.$statusCode.'  '.$content_respuesta;
			}else{
			   $cntestado=0;
			  if(strcmp(trim($statusCode), '98')==0){
			  $nota= 'Revisión en proceso ='.$codigoderespuesta.' hash='.$hash.'  '.$mensajeCDR.'  '.$fechaRespuesta.'  '.$horaRespuesta;	
				  $cntestado++;
			  }
			  
			  if(strcmp(trim($statusCode), '99')==0){
			  $nota= 'Proceso con errores ='.$codigoderespuesta.' hash='.$hash.'  '.$mensajeCDR.'  '.$fechaRespuesta.'  '.$horaRespuesta;
				  $cntestado++;	
			  }
			  
			  if(strcmp(trim($statusCode), '0')==0){
			  $nota= 'statusCode='.$codigoderespuesta.' hash='.$hash.'  '.$mensajeCDR.'  '.$fechaRespuesta.'  '.$horaRespuesta;
				  $cntestado++;	
			  }
			  
			  if($cntestado==0){
			  $nota= 'statusCode='.$codigoderespuesta.' hash='.$hash.'  '.$mensajeCDR.'  '.$fechaRespuesta.'  '.$horaRespuesta;	
			  }
			  			  
			  			  			  	
			  	
			}
			
			
			//significa que ha sido aceptada la comunicacion de baja caso contrario es error o esta en preceso
			if($statusCode==0){
			$mysqli = conectar();
			//************************************************/
			//EMPIEZA LA TRANSACCION
			$error_transaccion = 0; //variable para detectar error
			$mensaje="";
			$mysqli->autocommit(false);
			/************************************************/
			//actualiza con hash y fecha
			$palabra="update  tabla_resumen_diario set respuesta='".$nota."', fecha_respuesta='".$fechaRespuesta."', ";
		    $palabra=$palabra." estado='aceptado' where idtabla_resumen_diario='".$idcom_baja."'";

			$data=$mysqli->query($palabra)or ($mensaje=$mensaje.'Error actualizar resumen - diario '.$palabra and $error_transaccion=1);

			//actualiza hash y detalles en tabla boleta y pasaje
			//***********************************************************************
				//para normales y anulados primero el 2do anulado no cuenta
				$detallesunat=$nota;//$mensajeCDR." fecha_recibido='".$fechaRespuesta;
				$up="update tabla_boleta_pasaje set detalle='".$detallesunat."'";
				$up=$up." ,hash='".$hash."' where cdr='".trim($ticket)."'";
				$data=$mysqli->query($up)or ($mensaje=$mensaje.'Error actualizar ids - pasaje' and $error_transaccion=1);

				//para normales y anulados enviados
				$up1="update tabla_boleta_pasaje set detalle1='".$detallesunat."'";
				$up1=$up1." ,hashanulado='".$hash."' where cdr1='".trim($ticket)."'";
				$data1=$mysqli->query($up1)or ($mensaje=$mensaje.'Error actualizar ids - pasaje1' and $error_transaccion=1);


			//***********************************************************************

			//***********************************************************************
				$up="update tabla_boleta  set detalle='".$detallesunat."'";
				$up=$up.",hash='".$hash."' where cdr='".trim($ticket)."'";
				$data=$mysqli->query($up)or ($mensaje=$mensaje.'Error actualizar ids - boleta' and $error_transaccion=1);

				$up="update tabla_boleta  set detalle1='".$detallesunat."'";
				$up=$up.",hashanulado='".$hash."' where cdr1='".trim($ticket)."'";
				$data=$mysqli->query($up)or ($mensaje=$mensaje.'Error actualizar ids - boleta1' and $error_transaccion=1);

			//***********************************************************************
			//coloco el hash y valor cdr a boletas y pasajes, notas debito y credito porque ahora sunat ya no queire que se envie de la otra forma
			$cadena=" select ids,documento  from tabla_detalle_resumen_diario where idtabla_resumen_diario='".$idcom_baja."'";
			$query=$mysqli->query($cadena) or ($mensaje=$mensaje.'Error ids resumen - diario' and $error_transaccion=1);
			
			$melas='';
			while($rj=$query->fetch_row()){
				$ids=$rj[0];	
				$documeto=$rj[1];

				  if(strcmp(trim($documeto), 'ndebito')==0){					  	
					$up="update tabla_nota_debito set hash='".$hash."',respuesta='".$mensajeCDR."',fecha_respuesta='".$fechaRespuesta."'";
					$up=$up." where idtabla_nota_debito='".trim($ids)."'";
				
					$data=$mysqli->query($up)or ($mensaje=$mensaje.'Error actualizar ids - ndebito' and $error_transaccion=1);
				  }						  						  						  	
			
				  if(strcmp(trim($documeto), 'ncredito')==0){					  	
					$up="update tabla_nota_credito set hash='".$hash."',respuesta='".$mensajeCDR."',fecha_respuesta='".$fechaRespuesta."'";
					$up=$up." where idtabla_nota_credito='".trim($ids)."'";
				
					$data=$mysqli->query($up)or ($mensaje=$mensaje.'Error actualizar ids - ncredito' and $error_transaccion=1);
				  }	
				   
			}
				/***********IDENTIFICA ERROR EN LA TRANSACION**********/
				//VALIDO TRANSACCION
				/************************************************/
				if($error_transaccion>0 or $error_transaccion==1){
					$respuesta=$mysqli->rollback();//
					echo "error & ".$palabra." -> ".$mensaje." (Guardar captura de pantalla para actualizar manualmente) & ".$fechaRespuesta;
				}else {
					$respuesta=$mysqli->commit();
					echo "ok & Aceptado & ".$nota."  & ".$fechaRespuesta;
				}

			}else{
				echo "error & error al procesar... & ".$nota."  & -";
			}			
}
else{
	echo "error & error al enviar xml & ".$resultado."  & -";
}	
?>					