<?php
require_once("sanear.php");

class Operaciones{
	
	private $datosdeusuario;
	private $array_fecha;
	
	
	public function __construct()
	{
		$this->datosdeusuario=array();		
		$this->array_fecha=array();
	}
	
	//devuelve fecha y hora del sistema
	/**********************************************************************************************/
	public function tiempo($hr){
		$fechasistema=time();
		$horas = $hr;   						  //colocamos lo que queremos restar a la fecha actual
		$fechasistema += ($horas * 60 * 60); 		  // Convertimos las horas a segundos y las sumamos:
		$fs = date("d-m-Y", $fechasistema ); // Le damos al resultado el formato deseado:
		$hs = date("H:i:s", $fechasistema );
		
		$this->array_fecha[]=$fs;
		$this->array_fecha[]=$hs;
		
		
		return $this->array_fecha;				
	}//fin obtener fecha y hora del servidor
	/**********************************************************************************************/

	//devuelve correlativo 
	/**********************************************************************************************/
	public function dame_correlativo($idsucursal,$nombre_documento,$idtabla_usuario){
			
		$mensaje='vacio';
	    $mysqli=conectar();
		$cadena="select ".$nombre_documento." from tabla_correlativo where  idtabla_usuario='".$idtabla_usuario."'";
		$datacadena=$mysqli->query($cadena) or ($mensaje='error');
		
		while($c=$datacadena->fetch_assoc()){
			$correlativo=$c[$nombre_documento];
			
			if($correlativo==0){
				$correlativo=1;
			}
			
			if($idtabla_usuario<=9){
				
				if(strcmp(trim($nombre_documento), 'ticket')==0){$mensaje='TK0'.$idtabla_usuario.' & '.$correlativo;}
				if(strcmp(trim($nombre_documento), 'boleta')==0){$mensaje='BP0'.$idtabla_usuario.' & '.$correlativo;}
				if(strcmp(trim($nombre_documento), 'factura')==0){$mensaje='FT0'.$idtabla_usuario.' & '.$correlativo;}
				if(strcmp(trim($nombre_documento), 'traslado_interno')==0){$mensaje='TI0'.$idtabla_usuario.' & '.$correlativo;}
			}

			if(10<=$idtabla_usuario and $idtabla_usuario<=99){
				
				if(strcmp(trim($nombre_documento), 'ticket')==0){$mensaje='TK'.$idtabla_usuario.' & '.$correlativo;}
				if(strcmp(trim($nombre_documento), 'boleta')==0){$mensaje='BT'.$idtabla_usuario.' & '.$correlativo;}
				if(strcmp(trim($nombre_documento), 'factura')==0){$mensaje='FT'.$idtabla_usuario.' & '.$correlativo;}
				if(strcmp(trim($nombre_documento), 'traslado_interno')==0){$mensaje='TI'.$idtabla_usuario.' & '.$correlativo;}
			}
			
			if($idtabla_usuario>=100){
				
				if(strcmp(trim($nombre_documento), 'ticket')==0){$mensaje='T'.$idtabla_usuario.' & '.$correlativo;}
				if(strcmp(trim($nombre_documento), 'boleta')==0){$mensaje='B'.$idtabla_usuario.' & '.$correlativo;}
				if(strcmp(trim($nombre_documento), 'factura')==0){$mensaje='F'.$idtabla_usuario.' & '.$correlativo;}
				if(strcmp(trim($nombre_documento), 'traslado_interno')==0){$mensaje='I'.$idtabla_usuario.' & '.$correlativo;}
			}
						
			
		}
		
		desconectar($mysqli);
		
		return $mensaje;				
	}//fin obtener fecha y hora del servidor
	/**********************************************************************************************/


	
	//me devuelve los datos del usuario
	/**********************************************************************************************/
	public function get_data_de_usuario($name_usuario,$tabla){
		
		$s=new Sanear();
		$name_user=$name_usuario;
		$name_user_temp=$s->limpiarInput($name_usuario);
		
		if(strcmp($name_user_temp, 'ok')== 0){		
			$mysqli=conectar();
			
			$cadena="select nombre from tabla_empresa where predeterminada='si' limit 1";
			$query_cadena=$mysqli->query($cadena)or die("<script type=''>
																	alert('Error al obtener datos de la empresa');
																	window.location='cerrar.php';
			   													  </script>");

			$nombre_empresa='Piura Planet S.A.C';
			
			while($name_emp=$query_cadena->fetch_assoc()){
				$nombre_empresa=$name_emp['nombre'];
			}																  
			
			
			 $sentencia_usuario="select idtabla_".trim($tabla).",nombre, idtabla_ciudad  ";
			 $sentencia_usuario=$sentencia_usuario." from tabla_".trim($tabla)." where usuario='".$name_user."' and eliminado='no'";	
						
			
			 $query_usuario=$mysqli->query($sentencia_usuario)or die("<script type=''>
																	alert('Error al obtener datos de usuario - script.php'+$tabla);
																	window.location='cerrar.php';
			   													  </script>");
			
													   
	        while($reg=$query_usuario->fetch_assoc()){
	        	$this->datosdeusuario[]=$reg['idtabla_'.trim($tabla)]; //id_usuario [0]
				$this->datosdeusuario[]=$reg['nombre']; //nombre usuario [1]
				$this->datosdeusuario[]=self::get_nombre_xxx($reg['idtabla_ciudad'],'ciudad', 'nombre')  ; //sucursal [2]
				$this->datosdeusuario[]=$reg['idtabla_ciudad']; //idtabla_sucursal [3]

                //verifica si es un admisnistrador
				if(strcasecmp(trim($tabla),'adm')==0)
				{$this->datosdeusuario[]='si';} // es adm [4]
				else{
					$this->datosdeusuario[]='no'; // no es adm[4]
				}

			    //nombre de la empresa
				$this->datosdeusuario[]=$nombre_empresa; // nombre de empresa[5]
				
						
				// insertar,modificar,eliminar,compra,venta,servicio,caja,imprimir,sala,hospi,medico,traslado 				
				//permisos del administrador				
				if(strcmp($tabla, 'adm')==0){
				$this->datosdeusuario[]="si"; // permiso_insertar[6]					
				$this->datosdeusuario[]="si"; // permiso_modificar[7]					
				$this->datosdeusuario[]="si"; // permiso eliminar [8]				
				$this->datosdeusuario[]="si"; // permiso_auditar[9]
				}
				
				//permiso del usuario 
				if(strcmp($tabla, 'usuario')==0 ){
					
				$permisos="select insertar,modificar,eliminar,caja  from ";
				$permisos=$permisos."tabla_permiso where eliminado='no' and  idtabla_usuario='".$reg['idtabla_'.trim($tabla)]."'";
				
				
				$r_per=$mysqli->query($permisos) or die ($permisos."Errro al obtener permisos");
				
					while($reg_p=$r_per->fetch_assoc()){
						
						$this->datosdeusuario[]=$reg_p['insertar']; // permiso_insertar[6]
						$this->datosdeusuario[]=$reg_p['modificar']; // permiso_modificar[7]					
						$this->datosdeusuario[]=$reg_p['eliminar']; // permiso eliminar [8]				
						$this->datosdeusuario[]=$reg_p['caja'];
					}
				}
	        }	
			
			   if(sizeof($this->datosdeusuario)==0){
			    echo "<script type=''>
						alert('Nombre de usuario no valido..'+$sentencia_usuario);
						window.location='cerrar.php';
			  	  	  </script>";
			    }else{
			    	
				  return $this->datosdeusuario;
			    }
			    		
	    }else{	    	
			echo "<script type=''>
					alert('Nombre de usuario no valido');
					window.location='cerrar.php';
			  	  </script>";
	    }					   
	}//fin obtener datos de usuario
	/**********************************************************************************************/
	
	//valida si los datos de inyeccion sql
	/**********************************************************************************************/
	public function esvalido($dato){
		$s=new Sanear();
		$temp=$s->limpiarInput($dato);
		$respuesta="ok";
		$error="null";
		
		if(strcmp($temp, 'ok')== 0){
		    return $respuesta;	
		}else{			
			return $error;
		}		
	}	
	/**********************************************************************************************/

	//valida campos que no se deben repetir en la tablas
	/**********************************************************************************************/
	public function validar_insert($tabla,$campos,$datos,$tipo_dato,$long_dato){
		$s=new Sanear();
			
		$longitud=count($campos);
		$i=0;
		$cnt=0;
		$msj="ok";
		
		//limpiar datos
		/*##############################################################################################################*/
		while($i<$longitud and $cnt==0){
			
			$temp=$s->limpiarInput($datos[$i]);
						
			if(strcmp($temp, 'ok')== 0){
				
				//valida ruc y dni para algunas tablas
				/***************************************************************************************/					
				if(strcmp(trim($campos[$i]), 'ruc')==0 or strcmp(trim($campos[$i]), 'ruc_dni')==0 ){
								
						if(is_numeric(trim($datos[$i])) and (strlen(trim($datos[$i]))==11 or strlen(trim($datos[$i]))==8) ){					
									
					    }
						else{
							$msj=$campos[$i].' "'.$datos[$i].'" No Válido';
							$cnt++;							
						}
				}
				/***************************************************************************************/

				/****************************otras validacion*******************************************/
				/***************************************************************************************/
				
				/***************************************************************************************/
				/***************************************************************************************/
			   	
			}else{			
				$msj=$campos[$i].' "'.$datos[$i].'" No Válido';
				$cnt++;
			}
			
			$i++;
		}
        /*##############################################################################################################*/
        
        
        /*##############################################################################################################*/
        /*********************valido campos de tablas que no deben repetirse********************/
        $i=0;
        while($i<$longitud and $cnt==0){
        	
			if(strcmp($msj, 'ok')==0 and $cnt==0){
				
			//valida ruc y dni para algunas tablas
			/***************************************************************************************/
			/*if(strcmp(trim($tabla), 'empresa')==0 or strcmp(trim($tabla), 'cliente')==0 or strcmp(trim($tabla), 'proveedor')==0 or 
			   strcmp(trim($tabla), 'trabajador')==0 or strcmp(trim($tabla), 'trabajador_servicio')==0){*/
				
				/***********************************************************************************************/
				if(strcmp(trim($campos[$i]), 'documento')==0 or strcmp(trim($campos[$i]), 'ruc_dni')==0 ){
					
					$mysqli=conectar();
					
					$cadena="select *  from tabla_".$tabla." where ".trim($campos[$i])."='".trim($datos[$i])."' and eliminado='no'";
					$req=$mysqli->query($cadena) or ($msj='Error al verificar duplicidad de '.$campos[$i] and $cnt++);
					
					while($reg=$req->fetch_assoc()){
						$msj=' '.strtoupper($campos[$i]).' "'.$datos[$i].'" ya se encuentra registrado';
						$cnt++;
					}					
				}
				/***********************************************************************************************/
				

				/***********************************************************************************************/

				/***********************************************************************************************/
						
				/***********************************************************************************************/
				if(strcmp(trim($campos[$i]), 'codigo')==0){
					
					$mysqli=conectar();
					
					$cadena="select *  from tabla_".$tabla." where ".trim($campos[$i])."='".trim($datos[$i])."' and eliminado='no'";
					$req=$mysqli->query($cadena) or ($msj='Error al verificar duplicidad de '.$campos[$i] and $cnt++);
					
					while($reg=$req->fetch_assoc()){
						$msj=' '.strtoupper($campos[$i]).' "'.$datos[$i].'" ya se encuentra registrado';
						$cnt++;
					}
								
				}
				/***********************************************************************************************/
								
				/***********************************************validacion de mas tablas************************/	
				/***********************************************************************************************/
				
			}
			$i++;
		}
		/*##############################################################################################################*/
		
		
		 return $msj;		
	}	
	/**********************************************************************************************/	
	
	//====================================================================
	public static function get_nombre_xxx($id,$tabla,$valor){
	  //require_once ("../configuracion/configuracion/configuracion/index/conectar/conexion.php");
	  $mysqli=conectar();
	  $error=0;
	  
	  $cadena="select ".$valor." from tabla_".$tabla." where idtabla_".$tabla."='".$id."'";
	  $req=$mysqli->query($cadena) or ($error=1);
	  
	  $r=$req->fetch_assoc();
	  
	  if($error==0){
	  	if(isset($r[$valor])){return $r[$valor];}else{	return '';}

	  }else{
	  		
	  	return 'Error al obtener '.$valor.'...';
	  }		
		
	}
	//====================================================================
	
	
	//valida campos que no se deben repetir en la tablas al actualizar los campos
	/**********************************************************************************************/
	public function validar_update($tabla,$idtabla,$campo,$tipo_dato,$long_dato,$valor){
		$s=new Sanear();
				
		$cnt=0;
		$msj="ok";
		
		//limpiar datos
		/*##############################################################################################################*/
					
			$temp=$s->limpiarInput($valor);
						
			if(strcmp($temp, 'ok')== 0){
				
				//valida ruc y dni para algunas tablas
				/***************************************************************************************/
				if(strcmp(trim($campo), 'ruc')==0 or strcmp(trim($campo), 'documento')==0 ){
								
						if(is_numeric(trim($valor)) and (strlen(trim($valor))==11 or strlen(trim($valor))==8) ){					
									
					    }
						else{
							$msj=$campo.' "'.$valor.'" No Válido';
							$cnt++;							
						}
				 }				
				/***************************************************************************************/
				//valida ruc y dni para algunas tablas
				/***************************************************************************************/
				if(strcmp(trim($campo), 'nhc')==0){
								
						if(is_numeric(trim($valor)) and (strlen(trim($valor))==11 or strlen(trim($valor))==8) ){					
									
					    }
						else{
							$msj=$campo.' "'.$valor.'" ya existe en la bd';
							$cnt++;							
						}
				 }				
				/***************************************************************************************/
				//valida el formato de fechas de vencimiento y produccion

				/***************************************************************************************/
				if((strcmp(trim($campo), 'nombre')==0 or strcmp(trim($campo), 'usuario')==0 or strcmp(trim($campo), 'razon_social')==0 or
				    strcmp(trim($campo), 'documento')==0 or strcmp(trim($campo), 'ruc_dni')==0) and strcmp(trim($tabla), 'itinerario')>0){
					
					$mysqli=conectar();
					
					$cadena="select *  from tabla_".$tabla." where ".trim($campo)."='".trim($valor)."' and idtabla_".$tabla."<>'".$idtabla."' and  eliminado='no'";
					$req=$mysqli->query($cadena) or ($msj='Error al verificar duplicidad de? '.$campo and $cnt++);
					
					while($reg=$req->fetch_assoc()){
						$msj=' '.strtoupper($campo).' "'.$valor.'" ya se encuentra registrado...';
						$cnt++;
					}					
				}
				/***************************************************************************************/

				/***************************************************************************************/
				if(strcmp(trim($campo), 'codigo')==0){
					
					$mysqli=conectar();
					
					$cadena="select *  from tabla_".$tabla." where ".trim($campo)."='".trim($valor)."' and idtabla_".$tabla."<>'".$idtabla."' and  eliminado='no'";
					$req=$mysqli->query($cadena) or ($msj='Error al verificar duplicidad de? '.$campo and $cnt++);
					
					while($reg=$req->fetch_assoc()){
						$msj=' '.strtoupper($campo).' "'.$valor.'" ya se encuentra registrado';
						$cnt++;
					}						
				}
				/***************************************************************************************/
												
				
				/****************************otras validacion*******************************************/
				/***************************************************************************************/
				
				/***************************************************************************************/
				/***************************************************************************************/
			   	
			}
			else{			
				$msj=$campo.' "'.$valor.'" No Válido';
				$cnt++;
			}		
        /*##############################################################################################################*/

		
		
		 return $msj;		
	}	
	/**********************************************************************************************/		
	
	
}//fin operaciones

?>
